__gnu_debug::basic_string< _CharT, _Traits, _Allocator > Class Template Reference
Inheritance diagram for __gnu_debug::basic_string< _CharT, _Traits, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator < typename _Base::const_iterator, basic_string > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator < const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator < typename _Base::iterator, basic_string > | iterator
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator < iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef _Traits | traits_type
typedef _Traits::char_type | value_type

## Public Member Functions

| basic_string (const _Allocator &__a=_Allocator())
| basic_string (const _Base &__base)
| basic_string (const basic_string &__str)
| basic_string (const basic_string &__str, size_type __pos, size_type __n=_Base::npos, const _Allocator &__a=_Allocator())
| basic_string (const _CharT *__s, size_type __n, const _Allocator &__a=_Allocator())
| basic_string (const _CharT *__s, const _Allocator &__a=_Allocator())
| basic_string (size_type __n, _CharT __c, const _Allocator &__a=_Allocator())
template<typename _InputIterator >
| basic_string (_InputIterator __begin, _InputIterator __end, const _Allocator &__a=_Allocator())
| basic_string (basic_string &&__str) noexcept
| basic_string (std::initializer_list< _CharT > __l, const _Allocator &__a=_Allocator())
void | _M_attach (_Safe_iterator_base *__it, bool __constant)
void | _M_attach_single (_Safe_iterator_base *__it, bool __constant) throw ()
_Base & | _M_base () noexcept
const _Base & | _M_base () const noexcept
void | _M_detach (_Safe_iterator_base *__it)
void | _M_detach_single (_Safe_iterator_base *__it) throw ()
void | _M_invalidate_all () const
void | _M_invalidate_if (_Predicate __pred)
void | _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | append (const _CharT *__s, size_type __n)
basic_string & | append (const _CharT *__s)
basic_string & | append (size_type __n, _CharT __c)
template<typename _InputIterator >
basic_string & | append (_InputIterator __first, _InputIterator __last)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | append (initializer_list< _CharT > __l)
basic_string & | assign (const basic_string &__x)
basic_string & | assign (basic_string &&__x)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | assign (const _CharT *__s, size_type __n)
basic_string & | assign (const _CharT *__s)
basic_string & | assign (size_type __n, _CharT __c)
template<typename _InputIterator >
basic_string & | assign (_InputIterator __first, _InputIterator __last)
basic_string & | assign (std::initializer_list< _CharT > __l)
basic_string & | assign (const basic_string &__str)
basic_string & | assign (basic_string &&__str)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n)
const_reference | at (size_type __n) const
reference | at (size_type __n)
reference | back ()
const_reference | back () const
iterator | begin () noexcept
const_iterator | begin () const noexcept
const _CharT * | c_str () const noexcept
size_type | capacity () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
int | compare (const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
int | compare (const _CharT *__s) const
int | compare (size_type __pos1, size_type __n1, const _CharT *__s) const
int | compare (size_type __pos1, size_type __n1, const _CharT *__s, size_type __n2) const
int | compare (const basic_string &__str) const
int | compare (size_type __pos, size_type __n, const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
const _CharT * | data () const noexcept
bool | empty () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
basic_string & | erase (size_type __pos=0, size_type __n=_Base::npos)
iterator | erase (iterator __position)
iterator | erase (iterator __first, iterator __last)
iterator | erase (iterator __position)
iterator | erase (iterator __first, iterator __last)
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find (const _CharT *__s, size_type __pos=0) const
size_type | find (_CharT __c, size_type __pos=0) const noexcept
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const
size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_first_of (const _CharT *__s, size_type __pos=0) const
size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_last_not_of (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_last_not_of (const _CharT *__s, size_type __pos=_Base::npos) const
size_type | find_last_not_of (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_of (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_last_of (const _CharT *__s, size_type __pos=_Base::npos) const
size_type | find_last_of (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
reference | front ()
const_reference | front () const
allocator_type | get_allocator () const noexcept
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
basic_string & | insert (size_type __pos, const _CharT *__s)
basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
iterator | insert (iterator __p, _CharT __c)
void | insert (iterator __p, size_type __n, _CharT __c)
template<typename _InputIterator >
void | insert (iterator __p, _InputIterator __first, _InputIterator __last)
void | insert (iterator __p, std::initializer_list< _CharT > __l)
void | insert (iterator __p, size_type __n, _CharT __c)
void | insert (iterator __p, _InputIterator __beg, _InputIterator __end)
void | insert (iterator __p, initializer_list< _CharT > __l)
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
iterator | insert (iterator __p, _CharT __c)
size_type | length () const noexcept
size_type | max_size () const noexcept
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (const _CharT *__s)
basic_string & | operator+= (_CharT __c)
basic_string & | operator+= (std::initializer_list< _CharT > __l)
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator= (const basic_string &__str)
basic_string & | operator= (const _CharT *__s)
basic_string & | operator= (_CharT __c)
basic_string & | operator= (basic_string &&__str)
basic_string & | operator= (std::initializer_list< _CharT > __l)
const_reference | operator[] (size_type __pos) const
reference | operator[] (size_type __pos)
void | pop_back ()
void | push_back (_CharT __c)
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend () noexcept
const_reverse_iterator | rend () const noexcept
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
template<typename _InputIterator >
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __j1, _InputIterator __j2)
basic_string & | replace (iterator __i1, iterator __i2, std::initializer_list< _CharT > __l)
basic_string & | replace (size_type __pos, size_type __n, const basic_string &__str)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, initializer_list< _CharT > __l)
void | reserve (size_type __res_arg=0)
void | resize (size_type __n, _CharT __c)
void | resize (size_type __n)
size_type | rfind (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const
size_type | rfind (const _CharT *__s, size_type __pos=_Base::npos) const
size_type | rfind (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
void | shrink_to_fit ()
size_type | size () const noexcept
basic_string | substr (size_type __pos=0, size_type __n=_Base::npos) const
void | swap (basic_string< _CharT, _Traits, _Allocator > &__x)
void | swap (basic_string &__s)

## Public Attributes

_Safe_iterator_base * | _M_const_iterators
_Safe_iterator_base * | _M_iterators
unsigned int | _M_version

## Static Public Attributes

static const size_type | npos

## Protected Member Functions

void | _M_detach_all ()
void | _M_detach_singular ()
__gnu_cxx::__mutex & | _M_get_mutex () throw ()
void | _M_revalidate_singular ()
void | _M_swap (_Safe_sequence_base &__x)

## Detailed Description

### template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
class __gnu_debug::basic_string< _CharT, _Traits, _Allocator >

Class std::basic_string with safety/checking/debug instrumentation.

Definition at line 41 of file debug/string.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_attach | ( | _Safe_iterator_base * | __it,
|  | bool | __constant
| ) |  |

inherited

Attach an iterator to this sequence.

void __gnu_debug::_Safe_sequence_base::_M_attach_single | ( | _Safe_iterator_base * | __it,
|  | bool | __constant
| ) |  | throw ()

inherited

Likewise but not thread safe.

void __gnu_debug::_Safe_sequence_base::_M_detach | ( | _Safe_iterator_base * | __it | ) |

inherited

Detach an iterator from this sequence

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) |

protected inherited

Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

void __gnu_debug::_Safe_sequence_base::_M_detach_single | ( | _Safe_iterator_base * | __it | ) | throw ()

inherited

Likewise but not thread safe.

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) |

protected inherited

Detach all singular iterators.

Postcondition
  for all iterators i attached to this sequence, i->_M_version == _M_version.

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | throw ()

protected inherited

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const

inline inherited

Invalidates all iterators.

Definition at line 233 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

void __gnu_debug::_Safe_sequence< basic_string< _CharT, _Traits, _Allocator > >::_M_invalidate_if | ( | _Predicate | __pred | ) |

inherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) |

protected inherited

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) |

protected inherited

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

void __gnu_debug::_Safe_sequence< basic_string< _CharT, _Traits, _Allocator > >::_M_transfer_from_if | ( | _Safe_sequence< basic_string< _CharT, _Traits, _Allocator > > & | __from,
|  | _Predicate | __pred
| ) |  |

inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::append | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) |

inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::append | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n
| ) |  |

inherited

Append a substring.

Parameters

  __str | The string to append.
  __pos | Index of the first character of str to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if __pos is not a valid index.

This function appends __n characters from __str starting at __pos to this string. If __n is is larger than the number of available characters in __str, the remainder of __str is appended.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::append | ( | initializer_list< _CharT > | __l | ) |

inline inherited

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to append.

Returns
  Reference to this string.

Definition at line 1030 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) |

inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::assign | ( | basic_string< _CharT, _Traits, _Allocator > && | __str | ) |

inline inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

This function sets this string to the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 1079 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n
| ) |  |

inline inherited

Set value to a substring of a string.

Parameters

  __str | The string to use.
  __pos | Index of the first character of str.
  __n | Number of characters to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of __str consisting of __n characters at __pos. If __n is is larger than the number of available characters in __str, the remainder of __str is used.

Definition at line 1100 of file basic_string.h.

const_reference std::basic_string< _CharT, _Traits, _Allocator >::at | ( | size_type | __n | ) | const

inline inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 864 of file basic_string.h.

reference std::basic_string< _CharT, _Traits, _Allocator >::at | ( | size_type | __n | ) |

inline inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 883 of file basic_string.h.

reference std::basic_string< _CharT, _Traits, _Allocator >::back | ( |  | ) |

inline inherited

Returns a read/write reference to the data at the last element of the string.

Definition at line 913 of file basic_string.h.

const_reference std::basic_string< _CharT, _Traits, _Allocator >::back | ( |  | ) | const

inline inherited

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 921 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::capacity | ( |  | ) | const

inline noexcept inherited

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 776 of file basic_string.h.

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) | const

inline inherited

Compare to a string.

Parameters

  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __str, 0 if their values are equivalent, or > 0 if this string is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 2225 of file basic_string.h.

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str
| ) |  | const

inherited

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

int std::basic_string< _CharT, _Traits, _Allocator >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2
| ) |  | const

inherited

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

bool std::basic_string< _CharT, _Traits, _Allocator >::empty | ( |  | ) | const

inline noexcept inherited

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 811 of file basic_string.h.

iterator std::basic_string< _CharT, _Traits, _Allocator >::erase | ( | iterator | __position | ) |

inline inherited

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1378 of file basic_string.h.

iterator std::basic_string< _CharT, _Traits, _Allocator >::erase | ( | iterator | __first,
|  | iterator | __last
| ) |  |

inherited

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

size_type std::basic_string< _CharT, _Traits, _Allocator >::find | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1846 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2079 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_first_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1952 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2142 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::find_last_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2016 of file basic_string.h.

reference std::basic_string< _CharT, _Traits, _Allocator >::front | ( |  | ) |

inline inherited

Returns a read/write reference to the data at the first element of the string.

Definition at line 897 of file basic_string.h.

const_reference std::basic_string< _CharT, _Traits, _Allocator >::front | ( |  | ) | const

inline inherited

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 905 of file basic_string.h.

allocator_type std::basic_string< _CharT, _Traits, _Allocator >::get_allocator | ( |  | ) | const

inline noexcept inherited

Return copy of allocator used to construct this string.

Definition at line 1817 of file basic_string.h.

void std::basic_string< _CharT, _Traits, _Allocator >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c
| ) |  |

inline inherited

Insert multiple characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1185 of file basic_string.h.

void std::basic_string< _CharT, _Traits, _Allocator >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end
| ) |  |

inline inherited

Insert a range of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [__beg,__end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1202 of file basic_string.h.

void std::basic_string< _CharT, _Traits, _Allocator >::insert | ( | iterator | __p,
|  | initializer_list< _CharT > | __l
| ) |  |

inline inherited

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 1213 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str
| ) |  |

inline inherited

Insert value of a string.

Parameters

  __pos1 | Iterator referencing location in string to insert at.
  __str | The string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts value of __str starting at __pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1233 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n
| ) |  |

inline inherited

Insert a substring.

Parameters

  __pos1 | Iterator referencing location in string to insert at.
  __str | The string to insert.
  __pos2 | Start of characters in str to insert.
  __n | Number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos1 > size() or __pos2 > str.size().

Starting at pos1, insert __n character of __str beginning with __pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos1 is beyond the end of this string or __pos2 is beyond the end of __str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1255 of file basic_string.h.

iterator std::basic_string< _CharT, _Traits, _Allocator >::insert | ( | iterator | __p,
|  | _CharT | __c
| ) |  |

inline inherited

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1337 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::length | ( |  | ) | const

inline noexcept inherited

Returns the number of characters in the string, not including any null-termination.

Definition at line 721 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::max_size | ( |  | ) | const

inline noexcept inherited

Returns the size() of the largest possible string.

Definition at line 726 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) |

inline inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 932 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str
| ) |  |

inline inherited

Replace characters with value from another string.

Parameters

  __pos | Index of first character to replace.
  __n | Number of characters to be replaced.
  __str | String to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos+__n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1429 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2
| ) |  |

inline inherited

Replace characters with value from another string.

Parameters

  __pos1 | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __str | String to insert.
  __pos2 | Index of first character of str to use.
  __n2 | Number of characters from str to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos1 > size() or __pos2 > __str.size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos1,__pos1 + n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1451 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str
| ) |  |

inline inherited

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1538 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n
| ) |  |

inline inherited

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1557 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s
| ) |  |

inline inherited

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1578 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c
| ) |  |

inline inherited

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1599 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2
| ) |  |

inline inherited

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1623 of file basic_string.h.

basic_string& std::basic_string< _CharT, _Traits, _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | initializer_list< _CharT > | __l
| ) |  |

inline inherited

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1692 of file basic_string.h.

void std::basic_string< _CharT, _Traits, _Allocator >::reserve | ( | size_type | __res_arg = `0` | ) |

inherited

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

size_type std::basic_string< _CharT, _Traits, _Allocator >::rfind | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1891 of file basic_string.h.

size_type std::basic_string< _CharT, _Traits, _Allocator >::size | ( |  | ) | const

inline noexcept inherited

Returns the number of characters in the string, not including any null-termination.

Definition at line 715 of file basic_string.h.

void std::basic_string< _CharT, _Traits, _Allocator >::swap | ( | basic_string< _CharT, _Traits, _Allocator > & | __s | ) |

inherited

Swap contents with another string.

Parameters

  __s | String to swap with.

Exchanges the contents of this string with that of __s in constant time.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators

inherited

The list of constant iterators that reference this container.

Definition at line 184 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators

inherited

The list of mutable iterators that reference this container.

Definition at line 181 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version

mutable inherited

The container version number. This number may never be 0.

Definition at line 187 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

const size_type std::basic_string< _CharT, _Traits, _Allocator >::npos

static inherited

Value returned by various member functions when they fail.

Definition at line 285 of file basic_string.h.

The documentation for this class was generated from the following file:

- debug/string